# Shapes

- [Shape](https://docs.frends.com/reference/shapes/shape.md): Any visualized element in Frends process.
- [Event Shapes](https://docs.frends.com/reference/shapes/event-shapes.md): When something happens or needs to happen.
- [Trigger](https://docs.frends.com/reference/shapes/event-shapes/trigger.md): Starting condition for a Frends Process.
- [Return](https://docs.frends.com/reference/shapes/event-shapes/return.md): End element of a Process.
- [Intermediate Return](https://docs.frends.com/reference/shapes/event-shapes/intermediate-return.md): Return a response and continue processing asynchronously.
- [Throw](https://docs.frends.com/reference/shapes/event-shapes/throw.md): Interrupting Process in case something almost unexpected happens.
- [Catch](https://docs.frends.com/reference/shapes/event-shapes/catch.md): Catching the expected or unexpected errors thrown within the Process.
- [Decision Shapes](https://docs.frends.com/reference/shapes/decision-shapes.md): Conditionals in Frends processes.
- [Exclusive Decision](https://docs.frends.com/reference/shapes/decision-shapes/exclusive-decision.md): If statement in a process.
- [Inclusive Decision](https://docs.frends.com/reference/shapes/decision-shapes/inclusive-decision.md): Choose one or more paths based on conditions.
- [Activity Shapes](https://docs.frends.com/reference/shapes/activity-shapes.md): Performing all the logic for you in processes.
- [Task](https://docs.frends.com/reference/shapes/activity-shapes/task.md): Bread and butter of Frends process functionality.
- [Call Subprocess](https://docs.frends.com/reference/shapes/activity-shapes/call-subprocess.md): Reusable functionality within Frends.
- [Assign Variable](https://docs.frends.com/reference/shapes/activity-shapes/assign-variable.md): C# oneliner.
- [Code Task](https://docs.frends.com/reference/shapes/activity-shapes/code-task.md): Multitalent shape of Frends, adding the 'code' into 'low-code development'.
- [Shared State Task](https://docs.frends.com/reference/shapes/activity-shapes/shared-state-task.md): Internal temporary value storage in Frends.
- [DMN Task](https://docs.frends.com/reference/shapes/activity-shapes/dmn-task.md): Handling complex business logic in one shape.
- [AI Connector](https://docs.frends.com/reference/shapes/activity-shapes/ai-connector.md): Including AI to your Processes has never been simpler.
- [Scope Shapes](https://docs.frends.com/reference/shapes/scope-shapes.md): Curly brackets and related scopes.
- [Scope](https://docs.frends.com/reference/shapes/scope-shapes/scope.md): Scoping your process is important for resource and error management.
- [Foreach](https://docs.frends.com/reference/shapes/scope-shapes/foreach.md): Iterate all elements of a container object.
- [While](https://docs.frends.com/reference/shapes/scope-shapes/while.md): Iterate while condition is true.
- [Long Running Process Shapes](https://docs.frends.com/reference/shapes/long-running-process-shapes.md): Shapes for pausing and resuming a Process.
- [Checkpoint](https://docs.frends.com/reference/shapes/long-running-process-shapes/checkpoint.md): Store the state of your Process and dehydrate it.
- [Scheduled Resume](https://docs.frends.com/reference/shapes/long-running-process-shapes/scheduled-resume.md): Wait until the specified time, without consuming resources.
- [Signal Resume](https://docs.frends.com/reference/shapes/long-running-process-shapes/signal-resume.md): Remotely signal another Process to resume from dehydration.
- [Artifact Shapes](https://docs.frends.com/reference/shapes/artifact-shapes.md): Self-documenting processes.
- [Data Object Reference](https://docs.frends.com/reference/shapes/artifact-shapes/data-object-reference.md): Documentational shape to make data flows visible.
- [Data Store Reference](https://docs.frends.com/reference/shapes/artifact-shapes/data-store-reference.md): Documentational shape to make data flows visible.
- [Group](https://docs.frends.com/reference/shapes/artifact-shapes/group.md): Documentational shape to logically tie things together.
- [Text Annotation](https://docs.frends.com/reference/shapes/artifact-shapes/text-annotation.md): Documentational shape to add context to elements.
- [Sequence Flow](https://docs.frends.com/reference/shapes/sequence-flow.md): The arrows connecting shapes together to make a process.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.frends.com/reference/shapes.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
